# class SS7M2UA | SIGTRAN MTP2 User Adaptation Layer. More...
Full name | `TelEngine::SS7M2UA`
Definition | `#include <libs/ysig/yatesig.h>`
Inherits | TelEngine::SIGAdaptUser [public ], TelEngine::SS7Layer2 [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- SS7M2UA (const NamedList& params)
- virtual bool initialize (const NamedList* config)
- virtual bool control (Operation oper, NamedList* params = 0)
- virtual unsigned int status () const
- virtual bool transmitMSU (const SS7MSU& msu)
- virtual void recoverMSU (int sequence)
- virtual bool operational () const
- virtual int getSequence ()
- virtual void activeChange (bool active)
- inline int32_t iid () const

#### Protected Types

- enum LinkState { LinkDown, LinkReq, LinkReqEmg, LinkUp, LinkUpEmg, }

#### Protected Methods

- virtual void timerTick (const Time& when)
- SS7M2UAClient* client () const
- virtual bool processMGMT (unsigned char msgType, const DataBlock& msg, int streamId)
- virtual bool processMAUP (unsigned char msgType, const DataBlock& msg, int streamId)
- void postRetrieve ()

#### Protected Members

- SignallingTimer m_retrieve
- int32_t m_iid
- int m_linkState
- bool m_rpo
- bool m_longSeq

## Detailed Description

RFC3331 SS7 Layer 2 implementation over SCTP/IP. M2UA is intended to be used as a Provider-User where real MTP2 runs on a Signalling Gateway and MTP3 runs on an Application Server.

SS7M2UA (const NamedList& params) | ### SS7M2UA

Constructor

Parameters:

params | List of construction parameters

bool initialize (const NamedList* config) | ### initialize

[virtual]

Configure and initialize M2UA and its transport

Parameters:

config | Optional configuration parameters override

Returns: True if M2UA and the transport were initialized properly

Reimplemented from SignallingComponent.

bool control (Operation oper, NamedList* params = 0) | ### control

[virtual]

Execute a control operation. Operations can change the link status or can query the aligned status.

Parameters:

oper | Operation to execute
params | Optional parameters for the operation

Returns: True if the command completed successfully, for query operations also indicates the data link is aligned and operational

Reimplemented from SS7Layer2.

unsigned int status () | ### status

[const virtual]

Retrieve the current link status indications

Returns: Link status indication bits

Reimplemented from SS7Layer2.

bool transmitMSU (const SS7MSU& msu) | ### transmitMSU

[virtual]

Push a Message Signal Unit down the protocol stack

Parameters:

msu | Message data, starting with Service Indicator Octet

Returns: True if message was successfully queued

Reimplemented from SS7Layer2.

void recoverMSU (int sequence) | ### recoverMSU

[virtual]

Remove the MSUs waiting in the transmit queue and return them

Parameters:

sequence | First sequence number to recover, flush earlier packets

Reimplemented from SS7Layer2.

bool operational () | ### operational

[const virtual]

Check if the link is fully operational

Returns: True if the link is aligned and operational

Reimplemented from SS7Layer2.

int getSequence () | ### getSequence

[virtual]

Get the sequence number of the last MSU received, request if not available

Returns: Last FSN received, negative if not available

Reimplemented from SS7Layer2.

void activeChange (bool active) | ### activeChange

[virtual]

Traffic activity state change notification

Parameters:

active | True if the ASP is active and traffic is allowed

Reimplemented from SIGAdaptUser.

inline int32_t iid () | ### iid

[const]

Retrieve the numeric Interface Identifier (if any)

Returns: IID value, -1 if not set

enum LinkState { LinkDown, LinkReq, LinkReqEmg, LinkUp, LinkUpEmg, } | ### LinkState

[protected]

void timerTick (const Time& when) | ### timerTick

[protected virtual]

Periodical timer tick used to perform alignment and housekeeping

Parameters:

when | Time to use as computing base for events and timeouts

Reimplemented from SS7Layer2.

SS7M2UAClient* client () | ### client

[protected const]

bool processMGMT (unsigned char msgType, const DataBlock& msg, int streamId) | ### processMGMT

[protected virtual]

bool processMAUP (unsigned char msgType, const DataBlock& msg, int streamId) | ### processMAUP

[protected virtual]

void postRetrieve () | ### postRetrieve

[protected]

SignallingTimer m_retrieve | ### m_retrieve

[protected]

int32_t m_iid | ### m_iid

[protected]

int m_linkState | ### m_linkState

[protected]

bool m_rpo | ### m_rpo

[protected]

bool m_longSeq | ### m_longSeq

[protected]

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.